#ifndef FM2_HISTORYFOLDER_H
#define FM2_HISTORYFOLDER_H

#include <QObject>
#include "gobjectptr.h"
#include "filepath.h"
#include "iconinfo.h"
#include "folder.h"
namespace Fm {

class LIBFM_QT_API HistoryFolderList : public QObject {
    Q_OBJECT
public:
    explicit HistoryFolderList(QObject* parent = 0);
    ~HistoryFolderList(){};

    void insert(const FilePath& path);
    void remove(const FilePath& path);

    void clear();

    bool isempty();

    std::vector<QString> item(){
        return hlist_;
    }

    static bool judgeruning();

    static std::shared_ptr<HistoryFolderList> globalInstance();

private Q_SLOTS:
    void save();

private:
    void load();
    void queueSave();
    void reloadFolder();

    static void _onFileChanged(GFileMonitor* mon, GFile* gf, GFile* other, GFileMonitorEvent evt, HistoryFolderList* _this) {
        _this->onFileChanged(mon, gf, other, evt);
    }
    void onFileChanged(GFileMonitor* mon, GFile* gf, GFile* other, GFileMonitorEvent evt);

private:
    FilePath file;
    std::vector<QString> hlist_;
    GObjectPtr<GFileMonitor> mon;
    bool idle_handler;
    static std::weak_ptr<HistoryFolderList> globalInstance_;
    static bool runing;
};

}

#endif // FM2_HISTORYFOLDER_H
